import { addTranslation } from '../utils/i18n.js';
import type { TranslateDictionary } from '../lang/en.js';

export const Fr: TranslateDictionary = {
  'Start airplay': 'Démarrer la diffusion AirPlay',
  'Stop airplay': 'Arrêter la diffusion AirPlay',
  Audio: 'Audio',
  Captions: 'Sous-titres',
  'Enable captions': 'Activer les sous-titres',
  'Disable captions': 'Désactiver les sous-titres',
  'Start casting': 'Démarrer la diffusion (cast)',
  'Stop casting': 'Arrêter la diffusion (cast)',
  'Enter fullscreen mode': 'Mettre en mode plein écran',
  'Exit fullscreen mode': 'Quitter le mode plein écran',
  Mute: 'Désactiver le son',
  Unmute: 'Activer le son',
  'Enter picture in picture mode': 'Mettre en mode image-en-image (PiP)',
  'Exit picture in picture mode': 'Quitter le mode image-en-image (PiP)',
  Play: 'Lire',
  Pause: 'Pause',
  'Playback rate': 'Taux de lecture',
  'Playback rate {playbackRate}': 'Taux de lecture {playbackRate}',
  Quality: 'Qualité',
  'Seek backward': 'Reculer',
  'Seek forward': 'Avancer',
  Settings: 'Paramètres',
  'audio player': 'lecteur audio',
  'video player': 'lecteur vidéo',
  volume: 'volume',
  seek: 'se déplacer',
  'closed captions': 'sous-titres codés',
  'current playback rate': 'taux de lecture actuel',
  'playback time': 'durée de lecture',
  'media loading': 'chargement des médias',

  settings: 'paramètres',
  'audio tracks': 'pistes audio',
  quality: 'qualité',
  play: 'lire',
  pause: 'pause',
  mute: 'désactiver le son',
  unmute: 'activer le son',
  live: 'en direct',
  'start airplay': 'démarrer la diffusion AirPlay',
  'stop airplay': 'arrêter la diffusion AirPlay',
  'start casting': 'démarrer la diffusion (cast)',
  'stop casting': 'arrêter la diffusion (cast)',
  'enter fullscreen mode': 'mettre en mode plein écran',
  'exit fullscreen mode': 'quitter le mode plein écran',
  'enter picture in picture mode': 'mettre en mode image-en-image (PiP)',
  'exit picture in picture mode': 'quitter le mode image-en-image (PiP)',
  'seek to live': 'aller au direct',
  'playing live': 'lecture en direct',
  'seek back {seekOffset} seconds': 'reculer {seekOffset} secondes',
  'seek forward {seekOffset} seconds': 'avancer {seekOffset} secondes',
  'Network Error': 'Erreur réseau',
  'Decode Error': 'Erreur de décodage',
  'Source Not Supported': 'Source non supportée',
  'Encryption Error': 'Erreur de chiffrement',
  'A network error caused the media download to fail.':
    'Une erreur réseau a causé l’échec du téléchargement du média.',
  'A media error caused playback to be aborted. The media could be corrupt or your browser does not support this format.':
    'Une erreur de média a provoqué l’interruption de la lecture. Le média peut être corrompu ou votre navigateur ne prend pas en charge ce format.',
  'An unsupported error occurred. The server or network failed, or your browser does not support this format.':
    'Une erreur non supportée s’est produite. Le serveur ou le réseau a échoué, ou votre navigateur ne prend pas en charge ce format.',
  'The media is encrypted and there are no keys to decrypt it.':
    'Le média est chiffré et il n’y a pas de clés pour le déchiffrer.',
};

addTranslation('fr', Fr);
